/****************************************************************************/
/* Davi de Paula Cavalcanti - No. USP 2875167                               */
/* Rachel de Paula          - aluna especial da ps                         */
/* Rafael Caetano do Santos - No. USP 2860305                               */
/* EP - Algoritmo embrulho para presente 2D                                 */
/* MAC 331 - Prof. Coelho                                                   */
/* julho/2001                                                               */
/****************************************************************************/

// bibliotecas do OpenGL
#include <GL/glut.h>
#include <GL/gl.h>

// para utilizar a funo uppercase
#include <ctype.h>

// para utilizar a funo calloc
#include <stdlib.h>

// para utilizar a funo sleep
#include <unistd.h>

// Biblioteca para usar as rotinas de entrada e sada
#include <stdio.h>

// Biblioteca contendo as definies de tipos e constantes
#include "embrulho.h"

// Variveis que controlam a dimenso das janelas
int Altura = ALTURA_INICIAL;
int Largura = LARGURA_INICIAL;

// Delay inicializado com Fast
long int delay_time = MEDIUM;

// guarda o nmero de pontos dados
int n, contador;

// guarda os pontos dados no arquivo de entrada
tPointi *s; 

int step = 0;


/********************************************************/
/*            Procedimentos e Funes                   */
/********************************************************/

void glutStrokeString(const char *s)
{
  for (; *s != '\0'; s++)
    //glutStrokeCharacter(GLUT_STROKE_ROMAN, *s);
    glutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24 ,*s);
}

void normaliza(tPointi *s, int n)
{
  int i;
  int min_x, max_x, min_y, max_y;
  int delta_x, delta_y;
  float fator_x, fator_y;

  min_x = max_x = s[0][X];
  min_y = max_y = s[0][Y];

  for (i = 1; i < n; i++) {
    if (s[i][X] < min_x)
      min_x = s[i][X];
    else if (s[i][X] > max_x)
      max_x = s[i][X];

    if (s[i][Y] < min_y)
      min_y = s[i][Y]; 
    else if (s[i][Y] > max_y) 
      max_y = s[i][Y]; 
  }

  delta_x = max_x - min_x;
  delta_y = max_y - min_y;
  //printf("max_x = %d, max_y = %d\n", max_x, max_y);
  //printf("min_x = %d, min_y = %d\n", min_x, min_y);
  //printf("delta_x = %d, delta_y = %d\n", delta_x, delta_y);

  fator_x = (((float) (Largura - ORIGEM_X * 2)) / (float) delta_x);
  fator_y = (((float) (Altura - ORIGEM_Y * 2)) / (float) delta_y);
  //printf("fator_x = %f, fator_y = %f\n", fator_x, fator_y);

  for (i = 0; i < n; i++) {
    s[i][X] -= min_x;
    s[i][X] *= (float) fator_x;
    s[i][X] += ORIGEM_X;

    s[i][Y] -= min_y;
    s[i][Y] *= (float) fator_y;
    s[i][Y] += ORIGEM_Y;

    // printf("s[%d] = (%d, %d)\n", i, s[i][X], s[i][Y]);
  }

}

// Rotinas para impresso de pontos e arestas
void delay(){
  char str_cont[300];
  char *str_velo;
     
  usleep(delay_time);

  glColor3f(R_BG, G_BG, B_BG); // Cor de fundo  
  glRecti(0,0,Largura,30);
  glColor3f(R_PONTO, G_PONTO, B_PONTO); // Cor dos pontos
  glRasterPos2f(0,0);
  // Imprime a velocidade
  if(delay_time == FAST)
    str_velo = "Fast";
  else if(delay_time == MEDIUM)
    str_velo = "Medium";
  else if(delay_time == SLOW)
    str_velo = "Slow";  
  if(step)
    str_velo = "Step-By-Step";

  sprintf(str_cont, "Counter: %d                    Speed: %s", contador, str_velo);
  glutStrokeString(str_cont);
  
  glFlush();
  glutSwapBuffers(); 
}

void imprimePonto(tPointi p){
  // Desenha 5 pixels para cada ponto
  // O ponto  o pixel central
  glBegin(GL_POINTS);
  glVertex2i(p[X],p[Y]);
  glVertex2i(p[X]+1,p[Y]);
  glVertex2i(p[X],p[Y]+1);
  glVertex2i(p[X]-1,p[Y]);
  glVertex2i(p[X],p[Y]-1);
  glEnd();  
}

void imprimePontoDelay(tPointi p){
  // Desenha 5 pixels para cada ponto
  // O ponto  o pixel central
  imprimePonto(p);
  delay();
}

void imprimePontos(tPointi *vp, int n){
  int i;
  //Desenha somente os pontos que convergirem
  for (i = 0; i < n; i++){
    imprimePonto(vp[i]);
  }
}

void imprimePoligono(tPolygoni *p){
  int i;

  glColor3f(R_PONTO, G_PONTO, B_PONTO); // Cor do ponto  
  glBegin(GL_LINES);
  //printf("%d vertices: ", p->n);
  for(i=0; i<p->n-1; i++){
    glVertex2i(p->vertices[i][X],p->vertices[i][Y]);
    glVertex2i(p->vertices[i+1][X],p->vertices[i+1][Y]);
    //printf(" (%d,%d)->", p->vertices[i][X],p->vertices[i][Y]);
  }
  //printf("\n");
  glEnd();
  
  glFlush();
  glutSwapBuffers(); 
}

void limpaArestaDelay(tPointi p1, tPointi p2, tPolygoni *p){
  glColor3f(R_BG, G_BG, B_BG); // Cor de fundo  

  // imprimeAresta
  glBegin(GL_LINES);
  glVertex2i(p1[X],p1[Y]);
  glVertex2i(p2[X],p2[Y]);
  glEnd();

  glColor3f(R_PONTO, G_PONTO, B_PONTO); // Cor definida para ponto normal

  imprimePonto(p1);

  imprimePonto(p2);

  glColor3f(R_ARESTA, G_ARESTA, B_ARESTA); // Cor das arestas do fecho
  imprimePontos(s, n);
  imprimePoligono(p);

  delay();
}

void imprimeAresta(tPointi p1, tPointi p2){

  glBegin(GL_LINES);
  glVertex2i(p1[X],p1[Y]);
  glVertex2i(p2[X],p2[Y]);
  glEnd();

  delay();
}

void imprimeRectPonto(tPointi p){
  glBegin(GL_LINES);
  glVertex2i(p[X]-5,p[Y]-5);
  glVertex2i(p[X]+5,p[Y]-5);
  glVertex2i(p[X]+5,p[Y]+5);
  glVertex2i(p[X]-5,p[Y]+5);
  glEnd();

  delay();
}
void limpaRectPonto(tPointi p, tPolygoni *polig){
  glColor3f(R_BG, G_BG, B_BG); // Cor de fundo
  imprimeRectPonto(p);

  //  glColor3f(R_PONTO, G_PONTO, B_PONTO); // Cor definida para o ponto normal
  //  imprimePonto(p);
  
  imprimePontos(s, n);
  imprimePoligono(polig);

  delay();
}

void step_by_step(){
  char c;
  if(step) 
    c = getchar();
 
}

tPointi *le_entrada(FILE *arq, int *pn)
{
     int i;
     tPointi *s;

     fscanf(arq, "%d", pn);

     s = (tPointi *) calloc(*pn, sizeof(tPointi));
     if (s == NULL) {
	  perror("le_entrada");
	  exit (-1);
     }
     
     for (i = 0; i < *pn; i++) {
	  fscanf(arq, "%d %d", &s[i][X], &s[i][Y]);
     }

     return s;
}

// Primitivas
int Area2(tPointi a, tPointi b, tPointi c)
{
     return (a[X] * b[Y] - a[Y] * b[X] + a[Y] * c[X]
	     - a[X] * c[Y] + b[X] * c[Y] - c[X] * b[Y]);
}

int Migi(tPointi a, tPointi b, tPointi c)
{
  contador++;

  return (Area2(a, b, c) < 0);
}

tPolygoni *embrulho_presente(tPointi *s, int n){
     // Encontra o ponto mais `baixo'
     int i_0 = 0;
     int j_0;
     int i, j, k;
   
     //char str_cont[300];

     tPolygoni *conv;
     conv = (tPolygoni *) calloc(1, sizeof(tPolygoni));
     conv->vertices = (tPointi *) calloc(n, sizeof(tPointi));
     conv->n = 0;

     contador = 0;
     
     // Inicializao da parte grfica
     glMatrixMode(GL_PROJECTION);
     glLoadIdentity();
     glPushMatrix();
     gluOrtho2D(0, Largura-1, 0, Altura-1);
     glMatrixMode(GL_MODELVIEW);
     glViewport(0, 0, Largura, Altura);
     
     //Para limpar o campo de impresso
     glColor3f(R_BG, G_BG, B_BG);
     glRecti(0,0,Largura,Altura);
     
     // Imprime os pontos dados
     glColor3f(R_PONTO, G_PONTO, B_PONTO); // Cor definida para os pontos
     imprimePontos(s, n);

     if (step)
       printf("Para ir para o prximo passo pressione enter.");

     // Procurando ponto mais baixo
     // i_0, indice do ponto mais baixo inicialmente
     glColor3f(R_CANDIDATO, G_CANDIDATO, B_CANDIDATO); // Cor definida para o ponto mais baixo
     imprimePontoDelay(s[i_0]);       
     for (j = 1; j < n; j++){
       // Testando se j  mais baixo que i_0
       glColor3f(R_TESTE, G_TESTE, B_TESTE); // Cor definida para teste do ponto mais baixo
       imprimeRectPonto(s[j]);
       step_by_step();
       // Se j  mais baixo
       if (s[i_0][Y] > s[j][Y]){
	 // Mais baixo passa a ser j
	 glColor3f(R_PONTO, G_PONTO, B_PONTO); // Cor definida para o ponto normal
	 imprimePontoDelay(s[i_0]);
	 glColor3f(R_CANDIDATO, G_CANDIDATO, B_CANDIDATO); // Cor definida para o ponto mais baixo
	 imprimePontoDelay(s[j]);
	 i_0 = j;
       }
       glColor3f(R_PONTO, G_PONTO, B_PONTO); // Cor definida para o ponto normal
       limpaRectPonto(s[j], conv);
       
     }
  
     // i_0  ponto do fecho
     i = i_0; 
     conv->vertices[0][X] = s[i][X];
     conv->vertices[0][Y] = s[i][Y]; 
     k = 1;
     conv->n = k;
  
     do{
       // Acha a `prxima' aresta do fecho que tem uma extremidade
       // em i.
       // Teste necessrio para que j_0 seja diferente de i
       j_0 = 0;
       if(i == 0)
	 j_0 = 1;

       glColor3f(R_CANDIDATO, G_CANDIDATO, B_CANDIDATO); // Cor definida para aresta candidata
       imprimeAresta(s[i], s[j_0]);
       for (j = j_0+1; j < n; j++){
	 if((j!=i)){
	   glColor3f(R_TESTE, G_TESTE, B_TESTE); // Cor definida para o ponto de teste
	   imprimeRectPonto(s[j]);
	   step_by_step();	   

	   if (Migi(s[i],s[j_0],s[j])){
	     limpaArestaDelay(s[i], s[j_0], conv);
	     j_0 = j;
	     glColor3f(R_CANDIDATO, G_CANDIDATO, B_CANDIDATO); // Cor definida para aresta candidata
	     imprimeAresta(s[i], s[j]);
	   }

	   limpaRectPonto(s[j], conv); 
	 }

       }
       
       // j_0  o prximo ponto do fecho
       conv->vertices[k][X] = s[j_0][X];
       conv->vertices[k][Y] = s[j_0][Y];
       
       // Imprime Aresta do Fecho
       glColor3f(R_ARESTA, G_ARESTA, B_ARESTA); // Cor definida para as arestas do fecho
       imprimeAresta(s[i], s[j_0]);
       
       k++;
       conv->n = k;

       i = j_0;
       
     }while (i != i_0); // enquanto no fechou o polgono

     glMatrixMode(GL_PROJECTION);
     glPopMatrix();
     glMatrixMode(GL_MODELVIEW);     
     glutSwapBuffers();

     //printf("Right: %d\n", contador);

     return conv;
}

void load(){
  // Inicializao da parte grfica
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glPushMatrix();
  gluOrtho2D(0, Largura-1, 0, Altura-1);
  glMatrixMode(GL_MODELVIEW);
  glViewport(0, 0, Largura, Altura);
  
  //Para limpar o campo de impresso
  glColor3f(R_BG, G_BG, B_BG);
  glRecti(0,0,Largura,Altura);
  
  // Imprime os pontos dados
  glColor3f(R_PONTO, G_PONTO, B_PONTO); // Cor definida para os pontos
  imprimePontos(s, n);
  
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glMatrixMode(GL_MODELVIEW);     
}

void mouse(int b, int s, int x, int y){
  /*
  // Se o boto esquerdo foi acionado
  if (b==GLUT_LEFT_BUTTON) {
    printf("Botao esquerdo");
  }
  else if (b == GLUT_RIGHT_BUTTON) {
    if (s == GLUT_DOWN) {
    printf("Botao direito down");
    }
    else if (s == GLUT_UP) {
      printf("Botao direito up");
    }
  }
  */
}

void display(){
  glClearColor(0.0,0.0,0.0,1.0);
  glClear(GL_COLOR_BUFFER_BIT);
  
  // embrulho para presente
  // embrulho_presente(p, n);
  load();
  
  glutSwapBuffers(); 
}

// Acerta o ViewPort das janelas
void reshape(int widht, int height){
  Altura = height;
  Largura = widht;

  glutPostRedisplay();
}

void run(){
  embrulho_presente(s, n);
}

// Seta a varivel complexa usada no Julia-Fatou para a inicial
void reload(){

  // desenha pontos
  glutPostRedisplay();
}
  
void speed_menu(int val){
  if (val == 1) delay_time = SLOW;
  if (val == 2) delay_time = MEDIUM;
  if (val == 3) delay_time = FAST;

  if (val == 4) step = 1;
  else step =0;

  run();
}

// Funes que controlam o menu de sada
void main_menu(int val){
  if (val == 1) run();
  if (val == 2) reload();
  if (val == 3) exit(0);
}

// Funo que controla as interaes pelo teclado
void keyboard(unsigned char c, int x, int y){
 c = toupper(c);
 if ( c == 'Q') exit(0);
 if ( c == 'R') reload(); 
}



/********************************************************/
/*               PROGRAMA PRINCIPAL                     */
/********************************************************/

int main(int argc, char **argv){
  int submenu;

  // Le os pontos do arquivo de entrada
  FILE *arq_entrada = stdin;
  
  if (argc > 1) {
    char *nome_arq = argv[1];
    arq_entrada = fopen(nome_arq, "r");
    
    if (arq_entrada == NULL) {
      perror("main");
      exit(-1);
    }
  }
  
  s = le_entrada(arq_entrada, &n);
  fclose(arq_entrada);

  normaliza(s, n);
  
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA);
  glutInitWindowSize(Largura,Altura);
  glutCreateWindow("Embrulho para Presente");

  // call backs
  glutDisplayFunc(display);
  glutMouseFunc(mouse);
  glutKeyboardFunc(keyboard);
  glutReshapeFunc(reshape);
  glutMouseFunc(mouse);

  //Menu
  submenu = glutCreateMenu(speed_menu);
  glutAddMenuEntry("Slow",1);
  glutAddMenuEntry("Medium",2);
  glutAddMenuEntry("Fast",3);
  glutAddMenuEntry("Step-By-Step",4);

  glutCreateMenu(main_menu);
  glutAddMenuEntry("Run",1);
  glutAddMenuEntry("Reload",2);
  glutAddSubMenu("Speed",submenu);
  glutAddMenuEntry("Quit",3);
  glutAttachMenu(GLUT_LEFT_BUTTON);
  
  glutMainLoop();

  return 0;
}




