#include <stdio.h>

#define X      0
#define Y      1
#define DIM    2
#define PMAX 1024

typedef int tPointi[DIM];
// typedef tPointi tPolygoni[PMAX]; // poligono de pontos inteiros
// tPolygoni  conv;    // guarda o fecho

tPointi *le_entrada(FILE *arq, int *pn);
void embrulho_presente(tPointi *p, int n);
void imprime(tPointi *p, int n);

int main(int argc, char **argv) {

     FILE *arq_entrada = stdin;
     int n;
     tPointi *p; // guarda os pontos dados
     
     if (argc > 1) {
	  char *nome_arq = argv[1];
	  arq_entrada = fopen(nome_arq, "r");
	  
	  if (arq_entrada == NULL) {
	       perror("main");
	       exit(-1);
	  }
     }
     
     p = le_entrada(arq_entrada, &n);
     fclose(arq_entrada);

     embrulho_presente(p, n);

}

tPointi *le_entrada(FILE *arq, int *pn)
{
     int i;
     tPointi *p;

     fscanf(arq, "%d", pn);

     p = (tPointi *) calloc(*pn, sizeof(tPointi));
     if (p == NULL) {
	  perror("le_entrada");
	  exit (-1);
     }
     
     for (i = 0; i < *pn; i++) {
	  fscanf(arq, "%d %d", &p[i][X], &p[i][Y]);
     }

     return p;
}

void embrulho_presente(tPointi *p, int n)
{
     // Encontra o ponto mais `baixo'
     int i_0 = 0;
     int j_0;
     int i, j, k;
     tPointi *conv;
     
     conv = (tPointi *) calloc(n, sizeof(tPointi));

     for (j = 1; j < n; j++)
     {
	  if (p[i_0][Y] > p[j][Y]) 
	  {
	       i_0 = j;
	  }
     }   

  
     // i_0  ponto fo fecho
     i = i_0; 
     conv[0][X] = p[i][X];
     conv[0][Y] = p[i][Y]; 
     k = 0;    
  
     do
     {
       // Acha a `prxima' aresta do fecho que tem uma extremidade
       // em i.
       // Se i=0 ento j_0=1
       j_0 = 0;
       if(i == 0)
	 j_0 = 1;

       
       for (j = j_0+1; j < n; j++) 
	 {
	   if ((j!=i) && Migi(p[i],p[j_0],p[j]))
	     {
	       j_0 = j;
	     }  
	 }
       
       // j_0  o prximo ponto do fecho
       conv[k][X] = p[j_0][X];
       conv[k][Y] = p[j_0][Y];
       
       // Imprime Aresta
       printf("Aresta: %d %d %d %d\n",p[i][X], p[i][Y], 
	      p[j_0][X], p[j_0][Y]);
       
       k++;
       i = j_0;
       
     }while (i != i_0); // enquanto no fechou o polgono 
    
     // Devolve o fecho convexo
     imprime(conv, k);
}


int Area2(tPointi a, tPointi b, tPointi c)
{
     return (a[X] * b[Y] - a[Y] * b[X] + a[Y] * c[X]
	     - a[X] * c[Y] + b[X] * c[Y] - c[X] * b[Y]);
}

int Migi(tPointi a, tPointi b, tPointi c)
{
     return (Area2(a, b, c) < 0);
}

void imprime(tPointi *p, int n){
  // Imprime o poligono 
  int i;
  printf("Poligono\n");
  for (i = 0; i < n; i++){
    fprintf(stdout,"%d %d\n", p[i][X], p[i][Y]);
  }
}




